<?php
// ------------------------------------------------------------------------------------------------------
// EventScripts Keygroup Functions for PHP
// Copyright 2007 by Marc Hrsken <info@sourceplugins.de>
// You can use this sourcecode in your projects, but you are NOT allowed to change anything of the lines above or below.
function keygroup_read($file)
{
	$keygroupname = str_replace(array("es_", "_db.txt"),"",basename($file));
	$keygroupdata = array();
	$keygroupfile = @fopen($file,"r");
	$line = 0;
	
	while (@!feof($keygroupfile ))
	{
		$line += 1;
   		$buffer = @fgets($keygroupfile);
		if (empty($keygroup_name))
		{
			if (preg_match("#\"(.*?)\"#s",$buffer))
			{
				$keygroup_name = $keygroupname;
			}
			else
			{
				echo "KEYGROUP ERROR: Could not find keygroupname in file<br />";
				return FALSE;
			}
		}
		else
		{
			if (empty($keygroup_open))
			{
				if(trim($buffer) == "{")
				{
					$keygroup_open = 1;
				}
				else
				{
					echo "KEYGROUP ERROR: Could not find first open bracket in file (on line $line)<br />";
					return FALSE;
				}
			}
			else
			{
				if (empty($keygroup_keyname))
				{
					if (preg_match("#\"(.*?)\"#s",$buffer))
					{
						$keygroup_keyname = explode("\"",$buffer);
						$keygroup_keyname = $keygroup_keyname['1'];
					}
					else if(trim($buffer) != "}")
					{
						if (!empty($buffer))
						{
							echo "KEYGROUP ERROR: Could not find keyname in file (on line $line)<br />";
							return FALSE;
						}
					}
				}
				else
				{
					if (empty($keygroup_keyopen) || $keygroup_keyopen == 0)
					{
						if(trim($buffer) == "{")
						{
							$keygroup_keyopen = 1;
						}
						else
						{
							echo "KEYGROUP ERROR: Could not find key open bracket in file (on line $line)<br />";
							return FALSE;
						}
					}
					else if(trim($buffer) != "}")
					{
						if (preg_match("#\"(.*?)\"(.*?)\"(.*?)\"#s",$buffer))
						{
							$keygroup_arr = explode("\"",$buffer);
							$keygroup_variable = $keygroup_arr['1'];
							$keygroup_value = $keygroup_arr['3'];
							
							$keygroupdata[$keygroup_keyname][$keygroup_variable] = $keygroup_value;
						}
						else
						{
							echo "KEYGROUP ERROR: Could not find a variable and value in file (on line $line)<br />";
							return FALSE;
						}		
					}
					else
					{
						$keygroup_keyopen = 0;
						$keygroup_keyname = 0;	
					}
				}
			}
		}
	}
	return $keygroupdata;
}
function keygroup_write($array,$file)
{
	if(!is_array($array))
	{
		echo "KEYGROUP ERROR: The provided data is not an array<br />";
		return FALSE;
	}

	$keygroupname = str_replace(array("es_", "_db.txt"),"",basename($file));

	$buffer  = "\"".$keygroupname."\"\n{\n";
	foreach ($array as $datakey => $datavalue)
	{
		$buffer .= "\t\"".$datakey."\"\n\t{\n";
		foreach ($datavalue as $key => $value)
		{
			$buffer .= "\t\t\"".$key."\" \"".$value."\"\n";
		}
		$buffer .= "\t}\n";
	}
	$buffer .= "}";

	$handle = fopen($file,"w+");
	if (fwrite($handle,$buffer))
	{
   		fclose($handle);
		return TRUE;
	}
	else
	{
   		fclose($handle);
		return FALSE;
	}
}
// -------------------------------------------------------------------------------------------------------------
// End of Keygroup Funtions
?>